=== modified file 'Makefile'
--- Makefile	2015-07-06 20:09:47 +0000
+++ Makefile	2014-10-05 20:08:58 +0000
@@ -69,8 +69,6 @@
 GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
 GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
-LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
-LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
 CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
@@ -108,8 +106,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
-CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS=plugin-runner $(PLUGINS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
@@ -242,10 +239,6 @@
 	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
-plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
-	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
-		) $(LOADLIBES) $(LDLIBS) -o $@
-
 .PHONY : all doc html clean distclean mostlyclean maintainer-clean \
 	check run-client run-server install install-html \
 	install-server install-client-nokey install-client uninstall \
@@ -280,7 +273,6 @@
 	@echo "###################################################################"
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
-		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
@@ -360,12 +352,10 @@
 install-client-nokey: all doc
 	install --directory $(LIBDIR)/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
-		$(LIBDIR)/mandos/plugins.d \
-		$(LIBDIR)/mandos/plugin-helpers
+		$(LIBDIR)/mandos/plugins.d
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
-		install --directory "$(CONFDIR)/plugin-helpers"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"
@@ -391,9 +381,6 @@
 	install --mode=u=rwxs,go=rx \
 		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/plymouth
-	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugin-helpers \
-		plugin-helpers/mandos-client-iprouteadddel
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \

=== modified file 'TODO'
--- TODO	2015-07-06 20:09:47 +0000
+++ TODO	2015-05-22 20:23:46 +0000
@@ -20,7 +20,9 @@
 * mandos-applet
 
 * mandos-client
+** TODO [#A] --dh-params=FILE
 ** TODO [#B] Use capabilities instead of seteuid().
+   https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
 ** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
@@ -48,6 +50,12 @@
 ** kernel command line option for debug info
 
 * mandos (server)
+** TODO [#B] Work around Avahi issue
+   Avahi does not announce link-local addresses if any global
+   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
+** TODO [#B] --notify-command
+   This would allow the mandos.service to use
+   --notify-command="systemd-notify --pid READY=1"
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -84,6 +92,7 @@
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
 ** TODO D-Bus server properties; address, port, interface, etc.		     :2:
+** TODO [#C] In Python 3.3, use shlex.quote() instead of re.escape()
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2015-07-01 20:01:26 +0000
+++ debian/mandos-client.README.Debian	2013-10-28 10:04:05 +0000
@@ -16,8 +16,6 @@
   is possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
-	MANDOSPLUGINHELPERDIR=/usr/lib/$(dpkg-architecture \
-	-qDEB_HOST_MULTIARCH)/mandos/plugin-helpers \
 	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
 	)/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
@@ -93,4 +91,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Mon, 29 Jun 2015 18:17:41 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Oct 2013 11:02:26 +0100

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2015-07-06 20:09:47 +0000
+++ initramfs-tools-hook	2014-07-16 23:44:54 +0000
@@ -70,13 +70,11 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-PLUGINHELPERDIR="${MANDOSDIR}/plugin-helpers"
 HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}" \
-	"${DESTDIR}${PLUGINHELPERDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -100,21 +98,6 @@
     esac
 done
 
-# Copy the packaged plugin helpers
-for file in "$libdir"/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    # Is this plugin overridden?
-    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
-	continue
-    fi
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -126,17 +109,6 @@
     esac
 done
 
-# Copy any user-supplied plugin helpers
-for file in /etc/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2015-03-10 18:03:38 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2015-03-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -197,6 +197,16 @@
       </para>
     </refsect2>
     
+    <refsect2 id="sniff">
+      <title>How about sniffing the network traffic and decrypting it
+      later by physically grabbing the Mandos client and using its
+      key?</title>
+      <para>
+	We only use <acronym>PFS</acronym> (Perfect Forward Security)
+	key exchange algorithms in TLS, which protects against this.
+      </para>
+    </refsect2>
+    
     <refsect2 id="physgrab">
       <title>Physically grabbing the Mandos server computer?</title>
       <para>

=== modified file 'mandos'
--- mandos	2014-10-08 21:07:10 +0000
+++ mandos	2015-05-31 17:46:06 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,7 +36,10 @@
 
 from future_builtins import *
 
-import SocketServer as socketserver
+try:
+    import SocketServer as socketserver
+except ImportError:
+    import socketserver
 import socket
 import argparse
 import datetime
@@ -47,7 +50,10 @@
 import gnutls.library.functions
 import gnutls.library.constants
 import gnutls.library.types
-import ConfigParser as configparser
+try:
+    import ConfigParser as configparser
+except ImportError:
+    import configparser
 import sys
 import re
 import os
@@ -62,17 +68,24 @@
 import struct
 import fcntl
 import functools
-import cPickle as pickle
+try:
+    import cPickle as pickle
+except ImportError:
+    import pickle
 import multiprocessing
 import types
 import binascii
 import tempfile
 import itertools
 import collections
+import codecs
 
 import dbus
 import dbus.service
-import gobject
+try:
+    import gobject
+except ImportError:
+    from gi.repository import GObject as gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
@@ -98,10 +111,10 @@
 syslogger = None
 
 try:
-    if_nametoindex = (ctypes.cdll.LoadLibrary
-                      (ctypes.util.find_library("c"))
-                      .if_nametoindex)
+    if_nametoindex = ctypes.cdll.LoadLibrary(
+        ctypes.util.find_library("c")).if_nametoindex
 except (OSError, AttributeError):
+    
     def if_nametoindex(interface):
         "Get an interface index the hard way, i.e. using fcntl()"
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
@@ -116,10 +129,9 @@
     """init logger and add loglevel"""
     
     global syslogger
-    syslogger = (logging.handlers.SysLogHandler
-                 (facility =
-                  logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = "/dev/log"))
+    syslogger = (logging.handlers.SysLogHandler(
+        facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+        address = "/dev/log"))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -142,6 +154,7 @@
 
 class PGPEngine(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
+    
     def __init__(self):
         self.tempdir = tempfile.mkdtemp(prefix="mandos-")
         self.gnupgargs = ['--batch',
@@ -186,8 +199,8 @@
     
     def encrypt(self, data, password):
         passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir=self.tempdir
-                                         ) as passfile:
+        with tempfile.NamedTemporaryFile(
+                dir=self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
             proc = subprocess.Popen(['gpg', '--symmetric',
@@ -204,8 +217,8 @@
     
     def decrypt(self, data, password):
         passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir = self.tempdir
-                                         ) as passfile:
+        with tempfile.NamedTemporaryFile(
+                dir = self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
             proc = subprocess.Popen(['gpg', '--decrypt',
@@ -215,8 +228,7 @@
                                     stdin = subprocess.PIPE,
                                     stdout = subprocess.PIPE,
                                     stderr = subprocess.PIPE)
-            decrypted_plaintext, err = proc.communicate(input
-                                                        = data)
+            decrypted_plaintext, err = proc.communicate(input = data)
         if proc.returncode != 0:
             raise PGPError(err)
         return decrypted_plaintext
@@ -228,9 +240,11 @@
         return super(AvahiError, self).__init__(value, *args,
                                                 **kwargs)
 
+
 class AvahiServiceError(AvahiError):
     pass
 
+
 class AvahiGroupError(AvahiError):
     pass
 
@@ -256,10 +270,17 @@
     bus: dbus.SystemBus()
     """
     
-    def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768,
-                 protocol = avahi.PROTO_UNSPEC, bus = None):
+    def __init__(self,
+                 interface = avahi.IF_UNSPEC,
+                 name = None,
+                 servicetype = None,
+                 port = None,
+                 TXT = None,
+                 domain = "",
+                 host = "",
+                 max_renames = 32768,
+                 protocol = avahi.PROTO_UNSPEC,
+                 bus = None):
         self.interface = interface
         self.name = name
         self.type = servicetype
@@ -282,8 +303,8 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = str(self.server
-                        .GetAlternativeServiceName(self.name))
+        self.name = str(
+            self.server.GetAlternativeServiceName(self.name))
         self.rename_count += 1
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
@@ -344,8 +365,7 @@
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
                             str(error))
-            raise AvahiGroupError("State changed: {!s}"
-                                  .format(error))
+            raise AvahiGroupError("State changed: {!s}".format(error))
     
     def cleanup(self):
         """Derived from the Avahi example code"""
@@ -361,13 +381,12 @@
     def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
         logger.debug("Avahi server state change: %i", state)
-        bad_states = { avahi.SERVER_INVALID:
-                           "Zeroconf server invalid",
-                       avahi.SERVER_REGISTERING: None,
-                       avahi.SERVER_COLLISION:
-                           "Zeroconf server name collision",
-                       avahi.SERVER_FAILURE:
-                           "Zeroconf server failure" }
+        bad_states = {
+            avahi.SERVER_INVALID: "Zeroconf server invalid",
+            avahi.SERVER_REGISTERING: None,
+            avahi.SERVER_COLLISION: "Zeroconf server name collision",
+            avahi.SERVER_FAILURE: "Zeroconf server failure",
+        }
         if state in bad_states:
             if bad_states[state] is not None:
                 if error is None:
@@ -392,7 +411,7 @@
                                     follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
         self.server.connect_to_signal("StateChanged",
-                                 self.server_state_changed)
+                                      self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
 
@@ -400,10 +419,9 @@
     def rename(self, *args, **kwargs):
         """Add the new name to the syslog messages"""
         ret = AvahiService.rename(self, *args, **kwargs)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(self.name)))
+        syslogger.setFormatter(logging.Formatter(
+            'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
+            .format(self.name)))
         return ret
 
 
@@ -456,16 +474,17 @@
                           "fingerprint", "host", "interval",
                           "last_approval_request", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = { "timeout": "PT5M",
-                        "extended_timeout": "PT15M",
-                        "interval": "PT2M",
-                        "checker": "fping -q -- %%(host)s",
-                        "host": "",
-                        "approval_delay": "PT0S",
-                        "approval_duration": "PT1S",
-                        "approved_by_default": "True",
-                        "enabled": "True",
-                        }
+    client_defaults = {
+        "timeout": "PT5M",
+        "extended_timeout": "PT15M",
+        "interval": "PT2M",
+        "checker": "fping -q -- %%(host)s",
+        "host": "",
+        "approval_delay": "PT0S",
+        "approval_duration": "PT1S",
+        "approved_by_default": "True",
+        "enabled": "True",
+    }
     
     @staticmethod
     def config_parser(config):
@@ -487,6 +506,9 @@
             client["enabled"] = config.getboolean(client_name,
                                                   "enabled")
             
+            # Uppercase and remove spaces from fingerprint for later
+            # comparison purposes with return value from the
+            # fingerprint() function
             client["fingerprint"] = (section["fingerprint"].upper()
                                      .replace(" ", ""))
             if "secret" in section:
@@ -534,9 +556,6 @@
             self.expires = None
         
         logger.debug("Creating client %r", self.name)
-        # Uppercase and remove spaces from fingerprint for later
-        # comparison purposes with return value from the fingerprint()
-        # function
         logger.debug("  Fingerprint: %s", self.fingerprint)
         self.created = settings.get("created",
                                     datetime.datetime.utcnow())
@@ -549,18 +568,15 @@
         self.current_checker_command = None
         self.approved = None
         self.approvals_pending = 0
-        self.changedstate = (multiprocessing_manager
-                             .Condition(multiprocessing_manager
-                                        .Lock()))
-        self.client_structure = [attr for attr in
-                                 self.__dict__.iterkeys()
+        self.changedstate = multiprocessing_manager.Condition(
+            multiprocessing_manager.Lock())
+        self.client_structure = [attr
+                                 for attr in self.__dict__.iterkeys()
                                  if not attr.startswith("_")]
         self.client_structure.append("client_structure")
         
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj:
-                                              isinstance(obj,
-                                                         property)):
+        for name, t in inspect.getmembers(
+                type(self), lambda obj: isinstance(obj, property)):
             if not name.startswith("_"):
                 self.client_structure.append(name)
     
@@ -608,17 +624,14 @@
         # and every interval from then on.
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (int(self.interval
-                                           .total_seconds() * 1000),
-                                       self.start_checker))
+        self.checker_initiator_tag = gobject.timeout_add(
+            int(self.interval.total_seconds() * 1000),
+            self.start_checker)
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (int(self.timeout
-                                           .total_seconds() * 1000),
-                                       self.disable))
+        self.disable_initiator_tag = gobject.timeout_add(
+            int(self.timeout.total_seconds() * 1000), self.disable)
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -633,8 +646,7 @@
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info("Checker for %(name)s failed",
-                            vars(self))
+                logger.info("Checker for %(name)s failed", vars(self))
         else:
             self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
@@ -654,9 +666,8 @@
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (int(timeout.total_seconds()
-                                               * 1000), self.disable))
+            self.disable_initiator_tag = gobject.timeout_add(
+                int(timeout.total_seconds() * 1000), self.disable)
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -693,19 +704,20 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(str(getattr(self, attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = {
+                attr: re.escape(str(getattr(self, attr)))
+                for attr in self.runtime_expansions }
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
                 logger.error('Could not format string "%s"',
-                             self.checker_command, exc_info=error)
-                return True # Try again later
+                             self.checker_command,
+                             exc_info=error)
+                return True     # Try again later
             self.current_checker_command = command
             try:
-                logger.info("Starting checker %r for %s",
-                            command, self.name)
+                logger.info("Starting checker %r for %s", command,
+                            self.name)
                 # We don't need to redirect stdout and stderr, since
                 # in normal mode, that is already done by daemon(),
                 # and in debug mode we don't want to.  (Stdin is
@@ -720,16 +732,15 @@
                                        "stderr": wnull })
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
-                                                shell=True, cwd="/",
+                                                shell=True,
+                                                cwd="/",
                                                 **popen_args)
             except OSError as error:
                 logger.error("Failed to start subprocess",
                              exc_info=error)
                 return True
-            self.checker_callback_tag = (gobject.child_watch_add
-                                         (self.checker.pid,
-                                          self.checker_callback,
-                                          data=command))
+            self.checker_callback_tag = gobject.child_watch_add(
+                self.checker.pid, self.checker_callback, data=command)
             # The checker may have completed before the gobject
             # watch was added.  Check for this.
             try:
@@ -766,8 +777,10 @@
         self.checker = None
 
 
-def dbus_service_property(dbus_interface, signature="v",
-                          access="readwrite", byte_arrays=False):
+def dbus_service_property(dbus_interface,
+                          signature="v",
+                          access="readwrite",
+                          byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
     
@@ -783,6 +796,7 @@
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
                          " signature {!r}".format(signature))
+    
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -793,6 +807,7 @@
             func._dbus_name = func._dbus_name[:-14]
         func._dbus_get_args_options = {'byte_arrays': byte_arrays }
         return func
+    
     return decorator
 
 
@@ -807,11 +822,13 @@
                 "org.freedesktop.DBus.Property.EmitsChangedSignal":
                     "false"}
     """
+    
     def decorator(func):
         func._dbus_is_interface = True
         func._dbus_interface = dbus_interface
         func._dbus_name = dbus_interface
         return func
+    
     return decorator
 
 
@@ -827,9 +844,11 @@
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
+    
     def decorator(func):
         func._dbus_annotations = annotations
         return func
+    
     return decorator
 
 
@@ -838,6 +857,7 @@
     """
     pass
 
+
 class DBusPropertyAccessException(DBusPropertyException):
     """A property's access permissions disallows an operation.
     """
@@ -871,32 +891,29 @@
     def _get_all_dbus_things(self, thing):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((getattr(athing.__get__(self), "_dbus_name",
-                         name),
+        return ((getattr(athing.__get__(self), "_dbus_name", name),
                  athing.__get__(self))
                 for cls in self.__class__.__mro__
                 for name, athing in
-                inspect.getmembers(cls,
-                                   self._is_dbus_thing(thing)))
+                inspect.getmembers(cls, self._is_dbus_thing(thing)))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for cls in  self.__class__.__mro__:
-            for name, value in (inspect.getmembers
-                                (cls,
-                                 self._is_dbus_thing("property"))):
+        for cls in self.__class__.__mro__:
+            for name, value in inspect.getmembers(
+                    cls, self._is_dbus_thing("property")):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
         
         # No such property
-        raise DBusPropertyNotFound(self.dbus_object_path + ":"
-                                   + interface_name + "."
-                                   + property_name)
+        raise DBusPropertyNotFound("{}:{}.{}".format(
+            self.dbus_object_path, interface_name, property_name))
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ss",
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="ss",
                          out_signature="v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
@@ -927,7 +944,8 @@
                                             for byte in value))
         prop(value)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="s",
                          out_signature="a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
@@ -948,8 +966,8 @@
             if not hasattr(value, "variant_level"):
                 properties[name] = value
                 continue
-            properties[name] = type(value)(value, variant_level=
-                                           value.variant_level+1)
+            properties[name] = type(value)(
+                value, variant_level = value.variant_level + 1)
         return dbus.Dictionary(properties, signature="sv")
     
     @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
@@ -973,12 +991,14 @@
                                                    connection)
         try:
             document = xml.dom.minidom.parseString(xmlstring)
+            
             def make_tag(document, name, prop):
                 e = document.createElement("property")
                 e.setAttribute("name", name)
                 e.setAttribute("type", prop._dbus_signature)
                 e.setAttribute("access", prop._dbus_access)
                 return e
+            
             for if_tag in document.getElementsByTagName("interface"):
                 # Add property tags
                 for tag in (make_tag(document, name, prop)
@@ -996,10 +1016,8 @@
                             if (name == tag.getAttribute("name")
                                 and prop._dbus_interface
                                 == if_tag.getAttribute("name")):
-                                annots.update(getattr
-                                              (prop,
-                                               "_dbus_annotations",
-                                               {}))
+                                annots.update(getattr(
+                                    prop, "_dbus_annotations", {}))
                         for name, value in annots.items():
                             ann_tag = document.createElement(
                                 "annotation")
@@ -1010,8 +1028,8 @@
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
                         annotations().items()
-                        for name, annotations in
-                        self._get_all_dbus_things("interface")
+                        for name, annotations
+                        in self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
                         )).items():
                     ann_tag = document.createElement("annotation")
@@ -1046,8 +1064,7 @@
     """Convert a UTC datetime.datetime() to a D-Bus type."""
     if dt is None:
         return dbus.String("", variant_level = variant_level)
-    return dbus.String(dt.isoformat(),
-                       variant_level=variant_level)
+    return dbus.String(dt.isoformat(), variant_level=variant_level)
 
 
 def alternate_dbus_interfaces(alt_interface_names, deprecate=True):
@@ -1073,9 +1090,10 @@
     (from DBusObjectWithProperties) and interfaces (from the
     dbus_interface_annotations decorator).
     """
+    
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+                alt_interface_names.items()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1083,39 +1101,49 @@
                 # Ignore non-D-Bus attributes, and D-Bus attributes
                 # with the wrong interface name
                 if (not hasattr(attribute, "_dbus_interface")
-                    or not attribute._dbus_interface
-                    .startswith(orig_interface_name)):
+                    or not attribute._dbus_interface.startswith(
+                        orig_interface_name)):
                     continue
                 # Create an alternate D-Bus interface name based on
                 # the current name
-                alt_interface = (attribute._dbus_interface
-                                 .replace(orig_interface_name,
-                                          alt_interface_name))
+                alt_interface = attribute._dbus_interface.replace(
+                    orig_interface_name, alt_interface_name)
                 interface_names.add(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
-                    # Extract the original non-method undecorated
-                    # function by black magic
-                    nonmethod_func = (dict(
+                    if sys.version == 2:
+                        # Extract the original non-method undecorated
+                        # function by black magic
+                        nonmethod_func = (dict(
                             zip(attribute.func_code.co_freevars,
-                                attribute.__closure__))["func"]
-                                      .cell_contents)
+                                attribute.__closure__))
+                                          ["func"].cell_contents)
+                    else:
+                        nonmethod_func = attribute
                     # Create a new, but exactly alike, function
                     # object, and decorate it to be a new D-Bus signal
                     # with the alternate D-Bus interface name
-                    new_function = (dbus.service.signal
-                                    (alt_interface,
-                                     attribute._dbus_signature)
-                                    (types.FunctionType(
-                                nonmethod_func.func_code,
-                                nonmethod_func.func_globals,
-                                nonmethod_func.func_name,
-                                nonmethod_func.func_defaults,
-                                nonmethod_func.func_closure)))
+                    if sys.version == 2:
+                        new_function = types.FunctionType(
+                            nonmethod_func.func_code,
+                            nonmethod_func.func_globals,
+                            nonmethod_func.func_name,
+                            nonmethod_func.func_defaults,
+                            nonmethod_func.func_closure)
+                    else:
+                        new_function = types.FunctionType(
+                            nonmethod_func.__code__,
+                            nonmethod_func.__globals__,
+                            nonmethod_func.__name__,
+                            nonmethod_func.__defaults__,
+                            nonmethod_func.__closure__)
+                    new_function = (dbus.service.signal(
+                        alt_interface,
+                        attribute._dbus_signature)(new_function))
                     # Copy annotations, if any
                     try:
-                        new_function._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        new_function._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                     # Define a creator of a function to call both the
@@ -1126,11 +1154,13 @@
                         """This function is a scope container to pass
                         func1 and func2 to the "call_both" function
                         outside of its arguments"""
+                        
                         def call_both(*args, **kwargs):
                             """This function will emit two D-Bus
                             signals by calling func1 and func2"""
                             func1(*args, **kwargs)
                             func2(*args, **kwargs)
+                        
                         return call_both
                     # Create the "call_both" function and add it to
                     # the class
@@ -1141,20 +1171,20 @@
                     # object.  Decorate it to be a new D-Bus method
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (dbus.service.method
-                                      (alt_interface,
-                                       attribute._dbus_in_signature,
-                                       attribute._dbus_out_signature)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (
+                        dbus.service.method(
+                            alt_interface,
+                            attribute._dbus_in_signature,
+                            attribute._dbus_out_signature)
+                        (types.FunctionType(attribute.func_code,
+                                            attribute.func_globals,
+                                            attribute.func_name,
+                                            attribute.func_defaults,
+                                            attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                 # Is this a D-Bus property?
@@ -1163,23 +1193,21 @@
                     # object, and decorate it to be a new D-Bus
                     # property with the alternate D-Bus interface
                     # name.  Add it to the class.
-                    attr[attrname] = (dbus_service_property
-                                      (alt_interface,
-                                       attribute._dbus_signature,
-                                       attribute._dbus_access,
-                                       attribute
-                                       ._dbus_get_args_options
-                                       ["byte_arrays"])
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (dbus_service_property(
+                        alt_interface, attribute._dbus_signature,
+                        attribute._dbus_access,
+                        attribute._dbus_get_args_options
+                        ["byte_arrays"])
+                                      (types.FunctionType(
+                                          attribute.func_code,
+                                          attribute.func_globals,
+                                          attribute.func_name,
+                                          attribute.func_defaults,
+                                          attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                 # Is this a D-Bus interface?
@@ -1188,22 +1216,22 @@
                     # object.  Decorate it to be a new D-Bus interface
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (dbus_interface_annotations
-                                      (alt_interface)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (
+                        dbus_interface_annotations(alt_interface)
+                        (types.FunctionType(attribute.func_code,
+                                            attribute.func_globals,
+                                            attribute.func_name,
+                                            attribute.func_defaults,
+                                            attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
                 iname="_AlternateDBusNames_interface_annotation{}"
                 for interface_name in interface_names:
+                    
                     @dbus_interface_annotations(interface_name)
                     def func(self):
                         return { "org.freedesktop.DBus.Deprecated":
-                                     "true" }
+                                 "true" }
                     # Find an unused name
                     for aname in (iname.format(i)
                                   for i in itertools.count()):
@@ -1214,13 +1242,14 @@
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
                 cls = type(b"{}Alternate".format(cls.__name__),
-                           (cls,), attr)
+                           (cls, ), attr)
         return cls
+    
     return wrapper
 
 
 @alternate_dbus_interfaces({"se.recompile.Mandos":
-                                "se.bsnet.fukt.Mandos"})
+                            "se.bsnet.fukt.Mandos"})
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1230,7 +1259,7 @@
     """
     
     runtime_expansions = (Client.runtime_expansions
-                          + ("dbus_object_path",))
+                          + ("dbus_object_path", ))
     
     _interface = "se.recompile.Mandos.Client"
     
@@ -1244,14 +1273,15 @@
         client_object_name = str(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
-        self.dbus_object_path = (dbus.ObjectPath
-                                 ("/clients/" + client_object_name))
+        self.dbus_object_path = dbus.ObjectPath(
+            "/clients/" + client_object_name)
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
     
-    def notifychangeproperty(transform_func,
-                             dbus_name, type_func=lambda x: x,
-                             variant_level=1, invalidate_only=False,
+    def notifychangeproperty(transform_func, dbus_name,
+                             type_func=lambda x: x,
+                             variant_level=1,
+                             invalidate_only=False,
                              _interface=_interface):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
@@ -1264,26 +1294,27 @@
         variant_level: D-Bus variant level.  Default: 1
         """
         attrname = "_{}".format(dbus_name)
+        
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
                     if invalidate_only:
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary(),
-                                               dbus.Array
-                                               ((dbus_name,)))
+                        self.PropertiesChanged(
+                            _interface, dbus.Dictionary(),
+                            dbus.Array((dbus_name, )))
                     else:
-                        dbus_value = transform_func(type_func(value),
-                                                    variant_level
-                                                    =variant_level)
+                        dbus_value = transform_func(
+                            type_func(value),
+                            variant_level = variant_level)
                         self.PropertyChanged(dbus.String(dbus_name),
                                              dbus_value)
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary({
-                                    dbus.String(dbus_name):
-                                        dbus_value }), dbus.Array())
+                        self.PropertiesChanged(
+                            _interface,
+                            dbus.Dictionary({ dbus.String(dbus_name):
+                                              dbus_value }),
+                            dbus.Array())
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1295,9 +1326,9 @@
     enabled = notifychangeproperty(dbus.Boolean, "Enabled")
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
-    checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker:
-                                       checker is not None)
+    checker = notifychangeproperty(
+        dbus.Boolean, "CheckerRunning",
+        type_func = lambda checker: checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
     last_checker_status = notifychangeproperty(dbus.Int16,
@@ -1306,26 +1337,22 @@
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt64,
-                                          "ApprovalDelay",
-                                          type_func =
-                                          lambda td: td.total_seconds()
-                                          * 1000)
+    approval_delay = notifychangeproperty(
+        dbus.UInt64, "ApprovalDelay",
+        type_func = lambda td: td.total_seconds() * 1000)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
         type_func = lambda td: td.total_seconds() * 1000)
     host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(dbus.UInt64, "Timeout",
-                                   type_func = lambda td:
-                                       td.total_seconds() * 1000)
+    timeout = notifychangeproperty(
+        dbus.UInt64, "Timeout",
+        type_func = lambda td: td.total_seconds() * 1000)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
         type_func = lambda td: td.total_seconds() * 1000)
-    interval = notifychangeproperty(dbus.UInt64,
-                                    "Interval",
-                                    type_func =
-                                    lambda td: td.total_seconds()
-                                    * 1000)
+    interval = notifychangeproperty(
+        dbus.UInt64, "Interval",
+        type_func = lambda td: td.total_seconds() * 1000)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     secret = notifychangeproperty(dbus.ByteArray, "Secret",
                                   invalidate_only=True)
@@ -1469,7 +1496,8 @@
         return dbus.Boolean(bool(self.approvals_pending))
     
     # ApprovedByDefault - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
@@ -1477,7 +1505,8 @@
         self.approved_by_default = bool(value)
     
     # ApprovalDelay - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
@@ -1486,7 +1515,8 @@
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
@@ -1505,7 +1535,8 @@
         return dbus.String(self.fingerprint)
     
     # Host - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
@@ -1523,7 +1554,8 @@
         return datetime_to_dbus(self.last_enabled)
     
     # Enabled - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
@@ -1534,7 +1566,8 @@
             self.disable()
     
     # LastCheckedOK - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
@@ -1543,8 +1576,7 @@
         return datetime_to_dbus(self.last_checked_ok)
     
     # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n",
-                           access="read")
+    @dbus_service_property(_interface, signature="n", access="read")
     def LastCheckerStatus_dbus_property(self):
         return dbus.Int16(self.last_checker_status)
     
@@ -1559,7 +1591,8 @@
         return datetime_to_dbus(self.last_approval_request)
     
     # Timeout - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
@@ -1578,13 +1611,13 @@
                     is None):
                     return
                 gobject.source_remove(self.disable_initiator_tag)
-                self.disable_initiator_tag = (
-                    gobject.timeout_add(
-                        int((self.expires - now).total_seconds()
-                            * 1000), self.disable))
+                self.disable_initiator_tag = gobject.timeout_add(
+                    int((self.expires - now).total_seconds() * 1000),
+                    self.disable)
     
     # ExtendedTimeout - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
@@ -1593,7 +1626,8 @@
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
@@ -1604,12 +1638,13 @@
         if self.enabled:
             # Reschedule checker run
             gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
+            self.checker_initiator_tag = gobject.timeout_add(
+                value, self.start_checker)
+            self.start_checker() # Start one now, too
     
     # Checker - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
@@ -1617,7 +1652,8 @@
         self.checker_command = str(value)
     
     # CheckerRunning - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
@@ -1633,8 +1669,10 @@
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
-    @dbus_service_property(_interface, signature="ay",
-                           access="write", byte_arrays=True)
+    @dbus_service_property(_interface,
+                           signature="ay",
+                           access="write",
+                           byte_arrays=True)
     def Secret_dbus_property(self, value):
         self.secret = bytes(value)
     
@@ -1646,7 +1684,7 @@
         self._pipe = child_pipe
         self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
-            raise KeyError()
+            raise KeyError(fpr)
     
     def __getattribute__(self, name):
         if name == '_pipe':
@@ -1656,9 +1694,11 @@
         if data[0] == 'data':
             return data[1]
         if data[0] == 'function':
+            
             def func(*args, **kwargs):
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
+            
             return func
     
     def __setattr__(self, name, value):
@@ -1680,10 +1720,8 @@
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
+            session = gnutls.connection.ClientSession(
+                self.request, gnutls.connection .X509Credentials())
             
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
@@ -1698,9 +1736,8 @@
             priority = self.server.gnutls_priority
             if priority is None:
                 priority = "NORMAL"
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
+            gnutls.library.functions.gnutls_priority_set_direct(
+                session._c_object, priority, None)
             
             # Start communication using the Mandos protocol
             # Get protocol number
@@ -1726,8 +1763,8 @@
             approval_required = False
             try:
                 try:
-                    fpr = self.fingerprint(self.peer_certificate
-                                           (session))
+                    fpr = self.fingerprint(
+                        self.peer_certificate(session))
                 except (TypeError,
                         gnutls.errors.GNUTLSError) as error:
                     logger.warning("Bad certificate: %s", error)
@@ -1748,7 +1785,7 @@
                 while True:
                     if not client.enabled:
                         logger.info("Client %s is disabled",
-                                       client.name)
+                                    client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.Rejected("Disabled")
@@ -1801,9 +1838,9 @@
                         logger.warning("gnutls send failed",
                                        exc_info=error)
                         return
-                    logger.debug("Sent: %d, remaining: %d",
-                                 sent, len(client.secret)
-                                 - (sent_size + sent))
+                    logger.debug("Sent: %d, remaining: %d", sent,
+                                 len(client.secret) - (sent_size
+                                                       + sent))
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
@@ -1826,8 +1863,8 @@
     def peer_certificate(session):
         "Return the peer's OpenPGP certificate as a bytestring"
         # If not an OpenPGP certificate...
-        if (gnutls.library.functions
-            .gnutls_certificate_type_get(session._c_object)
+        if (gnutls.library.functions.gnutls_certificate_type_get(
+                session._c_object)
             != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
             # ...do the normal thing
             return session.peer_certificate
@@ -1847,36 +1884,32 @@
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
-        datum = (gnutls.library.types
-                 .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                             ctypes.POINTER
-                                             (ctypes.c_ubyte)),
-                                 ctypes.c_uint(len(openpgp))))
+        datum = gnutls.library.types.gnutls_datum_t(
+            ctypes.cast(ctypes.c_char_p(openpgp),
+                        ctypes.POINTER(ctypes.c_ubyte)),
+            ctypes.c_uint(len(openpgp)))
         # New empty GnuTLS certificate
         crt = gnutls.library.types.gnutls_openpgp_crt_t()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+        gnutls.library.functions.gnutls_openpgp_crt_init(
+            ctypes.byref(crt))
         # Import the OpenPGP public key into the certificate
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                    gnutls.library.constants
-                                    .GNUTLS_OPENPGP_FMT_RAW))
+        gnutls.library.functions.gnutls_openpgp_crt_import(
+            crt, ctypes.byref(datum),
+            gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
         # Verify the self signature in the key
         crtverify = ctypes.c_uint()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_verify_self(crt, 0,
-                                         ctypes.byref(crtverify)))
+        gnutls.library.functions.gnutls_openpgp_crt_verify_self(
+            crt, 0, ctypes.byref(crtverify))
         if crtverify.value != 0:
             gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-            raise (gnutls.errors.CertificateSecurityError
-                   ("Verify failed"))
+            raise gnutls.errors.CertificateSecurityError(
+                "Verify failed")
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
         # Get the fingerprint from the certificate into the buffer
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                             ctypes.byref(buf_len)))
+        gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint(
+            crt, ctypes.byref(buf), ctypes.byref(buf_len))
         # Deinit the certificate
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         # Convert the buffer to a Python bytestring
@@ -1888,6 +1921,7 @@
 
 class MultiprocessingMixIn(object):
     """Like socketserver.ThreadingMixIn, but with multiprocessing"""
+    
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
@@ -1905,6 +1939,7 @@
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
+    
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
@@ -1931,8 +1966,11 @@
         interface:      None or a network interface name (string)
         use_ipv6:       Boolean; to use IPv6 or not
     """
+    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, socketfd=None):
+                 interface=None,
+                 use_ipv6=True,
+                 socketfd=None):
         """If socketfd is set, use that file descriptor instead of
         creating a new one with socket.socket().
         """
@@ -1979,10 +2017,9 @@
                              self.interface)
             else:
                 try:
-                    self.socket.setsockopt(socket.SOL_SOCKET,
-                                           SO_BINDTODEVICE,
-                                           (self.interface + "\0")
-                                           .encode("utf-8"))
+                    self.socket.setsockopt(
+                        socket.SOL_SOCKET, SO_BINDTODEVICE,
+                        (self.interface + "\0").encode("utf-8"))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -2006,8 +2043,7 @@
                 self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
-                self.server_address = (self.server_address[0],
-                                       0)
+                self.server_address = (self.server_address[0], 0)
 #                 if self.interface:
 #                     self.server_address = (self.server_address[0],
 #                                            0, # port
@@ -2027,9 +2063,14 @@
     
     Assumes a gobject.MainLoop event loop.
     """
+    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True, socketfd=None):
+                 interface=None,
+                 use_ipv6=True,
+                 clients=None,
+                 gnutls_priority=None,
+                 use_dbus=True,
+                 socketfd=None):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2041,6 +2082,7 @@
                                 interface = interface,
                                 use_ipv6 = use_ipv6,
                                 socketfd = socketfd)
+    
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2050,15 +2092,17 @@
     
     def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(parent_pipe.fileno(),
-                             gobject.IO_IN | gobject.IO_HUP,
-                             functools.partial(self.handle_ipc,
-                                               parent_pipe =
-                                               parent_pipe,
-                                               proc = proc))
+        gobject.io_add_watch(
+            parent_pipe.fileno(),
+            gobject.IO_IN | gobject.IO_HUP,
+            functools.partial(self.handle_ipc,
+                              parent_pipe = parent_pipe,
+                              proc = proc))
     
-    def handle_ipc(self, source, condition, parent_pipe=None,
-                   proc = None, client_object=None):
+    def handle_ipc(self, source, condition,
+                   parent_pipe=None,
+                   proc = None,
+                   client_object=None):
         # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | gobject.IO_HUP):
             # Wait for other process to exit
@@ -2087,14 +2131,13 @@
                 parent_pipe.send(False)
                 return False
             
-            gobject.io_add_watch(parent_pipe.fileno(),
-                                 gobject.IO_IN | gobject.IO_HUP,
-                                 functools.partial(self.handle_ipc,
-                                                   parent_pipe =
-                                                   parent_pipe,
-                                                   proc = proc,
-                                                   client_object =
-                                                   client))
+            gobject.io_add_watch(
+                parent_pipe.fileno(),
+                gobject.IO_IN | gobject.IO_HUP,
+                functools.partial(self.handle_ipc,
+                                  parent_pipe = parent_pipe,
+                                  proc = proc,
+                                  client_object = client))
             parent_pipe.send(True)
             # remove the old hook in favor of the new above hook on
             # same fileno
@@ -2106,15 +2149,15 @@
             
             parent_pipe.send(('data', getattr(client_object,
                                               funcname)(*args,
-                                                         **kwargs)))
+                                                        **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
+                parent_pipe.send(('function', ))
             else:
-                parent_pipe.send(('data', client_object
-                                  .__getattribute__(attrname)))
+                parent_pipe.send((
+                    'data', client_object.__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -2151,21 +2194,17 @@
     # avoid excessive use of external libraries.
     
     # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
     # RFC 3339 "duration" tokens, syntax, and semantics; taken from
     # the "duration" ABNF definition in RFC 3339, Appendix A.
     token_end = Token(re.compile(r"$"), None, frozenset())
     token_second = Token(re.compile(r"(\d+)S"),
                          datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
+                         frozenset((token_end, )))
     token_minute = Token(re.compile(r"(\d+)M"),
                          datetime.timedelta(minutes=1),
                          frozenset((token_second, token_end)))
@@ -2187,7 +2226,7 @@
                        frozenset((token_month, token_end)))
     token_week = Token(re.compile(r"(\d+)W"),
                        datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
+                       frozenset((token_end, )))
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
@@ -2195,7 +2234,7 @@
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset((token_duration, )) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2218,7 +2257,8 @@
                 break
         else:
             # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
     # End token found
     return value
 
@@ -2261,8 +2301,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}"
-                                 .format(suffix))
+                raise ValueError("Unknown suffix {!r}".format(suffix))
         except IndexError as e:
             raise ValueError(*(e.args))
         timevalue += delta
@@ -2284,7 +2323,8 @@
         # Close all standard open file descriptors
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV, "{} not a character device"
+            raise OSError(errno.ENODEV,
+                          "{} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2356,7 +2396,8 @@
                         "port": "",
                         "debug": "False",
                         "priority":
-                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
+                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
+                        ":+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
                         "servicename": "Mandos",
                         "use_dbus": "True",
                         "use_ipv6": "True",
@@ -2366,13 +2407,12 @@
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
                         "zeroconf": "True",
-                        }
+                    }
     
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
-    server_config.read(os.path.join(options.configdir,
-                                    "mandos.conf"))
+    server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
@@ -2396,9 +2436,9 @@
     # Override the settings from the config file with command line
     # options, if set.
     for option in ("interface", "address", "port", "debug",
-                   "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "priority", "servicename", "configdir", "use_dbus",
+                   "use_ipv6", "debuglevel", "restore", "statedir",
+                   "socket", "foreground", "zeroconf"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2419,11 +2459,10 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
+    if (not server_settings["zeroconf"]
+        and not (server_settings["port"]
+                 or server_settings["socket"] != "")):
+        parser.error("Needs port or socket to work without Zeroconf")
     
     # For convenience
     debug = server_settings["debug"]
@@ -2445,11 +2484,10 @@
             initlogger(debug, level)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(server_settings
-                                        ["servicename"])))
+        syslogger.setFormatter(
+            logging.Formatter('Mandos ({}) [%(process)d]:'
+                              ' %(levelname)s: %(message)s'.format(
+                                  server_settings["servicename"])))
     
     # Parse config file with clients
     client_config = configparser.SafeConfigParser(Client
@@ -2463,23 +2501,21 @@
     socketfd = None
     if server_settings["socket"] != "":
         socketfd = server_settings["socket"]
-    tcp_server = MandosServer((server_settings["address"],
-                               server_settings["port"]),
-                              ClientHandler,
-                              interface=(server_settings["interface"]
-                                         or None),
-                              use_ipv6=use_ipv6,
-                              gnutls_priority=
-                              server_settings["priority"],
-                              use_dbus=use_dbus,
-                              socketfd=socketfd)
+    tcp_server = MandosServer(
+        (server_settings["address"], server_settings["port"]),
+        ClientHandler,
+        interface=(server_settings["interface"] or None),
+        use_ipv6=use_ipv6,
+        gnutls_priority=server_settings["priority"],
+        use_dbus=use_dbus,
+        socketfd=socketfd)
     if not foreground:
         pidfilename = "/run/mandos.pid"
         if not os.path.isdir("/run/."):
             pidfilename = "/var/run/mandos.pid"
         pidfile = None
         try:
-            pidfile = open(pidfilename, "w")
+            pidfile = codecs.open(pidfilename, "w", encoding="utf-8")
         except IOError as e:
             logger.error("Could not open file %r", pidfilename,
                          exc_info=e)
@@ -2512,8 +2548,8 @@
         def debug_gnutls(level, string):
             logger.debug("GnuTLS: %s", string[:-1])
         
-        (gnutls.library.functions
-         .gnutls_global_set_log_function(debug_gnutls))
+        gnutls.library.functions.gnutls_global_set_log_function(
+            debug_gnutls)
         
         # Redirect stdin so all checkers get /dev/null
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
@@ -2539,25 +2575,26 @@
     if use_dbus:
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
-                                            bus, do_not_queue=True)
-            old_bus_name = (dbus.service.BusName
-                            ("se.bsnet.fukt.Mandos", bus,
-                             do_not_queue=True))
-        except dbus.exceptions.NameExistsException as e:
+                                            bus,
+                                            do_not_queue=True)
+            old_bus_name = dbus.service.BusName(
+                "se.bsnet.fukt.Mandos", bus,
+                do_not_queue=True)
+        except dbus.exceptions.DBusException as e:
             logger.error("Disabling D-Bus:", exc_info=e)
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     if zeroconf:
         protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
+        service = AvahiServiceToSyslog(
+            name = server_settings["servicename"],
+            servicetype = "_mandos._tcp",
+            protocol = protocol,
+            bus = bus)
         if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (server_settings["interface"]
-                                  .encode("utf-8")))
+            service.interface = if_nametoindex(
+                server_settings["interface"].encode("utf-8"))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2582,20 +2619,21 @@
     if server_settings["restore"]:
         try:
             with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = (pickle.load
-                                                     (stored_state))
+                clients_data, old_client_settings = pickle.load(
+                    stored_state)
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {}"
-                                .format(os.strerror(e.errno)))
+                logger.warning("Could not load persistent state:"
+                               " {}".format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
                                 exc_info=e)
                 raise
         except EOFError as e:
             logger.warning("Could not load persistent state: "
-                           "EOFError:", exc_info=e)
+                           "EOFError:",
+                           exc_info=e)
     
     with PGPEngine() as pgp:
         for client_name, client in clients_data.items():
@@ -2613,9 +2651,9 @@
                     # For each value in new config, check if it
                     # differs from the old config value (Except for
                     # the "secret" attribute)
-                    if (name != "secret" and
-                        value != old_client_settings[client_name]
-                        [name]):
+                    if (name != "secret"
+                        and (value !=
+                             old_client_settings[client_name][name])):
                         client[name] = value
                 except KeyError:
                     pass
@@ -2630,34 +2668,34 @@
                     if not client["last_checked_ok"]:
                         logger.warning(
                             "disabling client {} - Client never "
-                            "performed a successful checker"
-                            .format(client_name))
+                            "performed a successful checker".format(
+                                client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
                             "disabling client {} - Client last"
-                            " checker failed with error code {}"
-                            .format(client_name,
-                                    client["last_checker_status"]))
+                            " checker failed with error code"
+                            " {}".format(
+                                client_name,
+                                client["last_checker_status"]))
                         client["enabled"] = False
                     else:
-                        client["expires"] = (datetime.datetime
-                                             .utcnow()
-                                             + client["timeout"])
+                        client["expires"] = (
+                            datetime.datetime.utcnow()
+                            + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled"
-                                     .format(client_name))
+                                     " keeping {} enabled".format(
+                                         client_name))
             try:
-                client["secret"] = (
-                    pgp.decrypt(client["encrypted_secret"],
-                                client_settings[client_name]
-                                ["secret"]))
+                client["secret"] = pgp.decrypt(
+                    client["encrypted_secret"],
+                    client_settings[client_name]["secret"])
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret"
-                             .format(client_name))
-                client["secret"] = (
-                    client_settings[client_name]["secret"])
+                logger.debug("Failed to decrypt {} old secret".format(
+                    client_name))
+                client["secret"] = (client_settings[client_name]
+                                    ["secret"])
     
     # Add/remove clients based on new changes made to config
     for client_name in (set(old_client_settings)
@@ -2670,7 +2708,8 @@
     # Create all client objects
     for client_name, client in clients_data.items():
         tcp_server.clients[client_name] = client_class(
-            name = client_name, settings = client,
+            name = client_name,
+            settings = client,
             server_settings = server_settings)
     
     if not tcp_server.clients:
@@ -2678,10 +2717,10 @@
     
     if not foreground:
         if pidfile is not None:
+            pid = os.getpid()
             try:
                 with pidfile:
-                    pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
+                    print(pid, file=pidfile)
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2692,19 +2731,22 @@
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        @alternate_dbus_interfaces({"se.recompile.Mandos":
-                                        "se.bsnet.fukt.Mandos"})
+        
+        @alternate_dbus_interfaces(
+            { "se.recompile.Mandos": "se.bsnet.fukt.Mandos" })
         class MandosDBusService(DBusObjectWithProperties):
             """A D-Bus proxy object"""
+            
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
+            
             _interface = "se.recompile.Mandos"
             
             @dbus_interface_annotations(_interface)
             def _foo(self):
-                return { "org.freedesktop.DBus.Property"
-                         ".EmitsChangedSignal":
-                             "false"}
+                return {
+                    "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                    "false" }
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -2724,8 +2766,7 @@
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
-                return dbus.Array(c.dbus_object_path
-                                  for c in
+                return dbus.Array(c.dbus_object_path for c in
                                   tcp_server.clients.itervalues())
             
             @dbus.service.method(_interface,
@@ -2780,8 +2821,8 @@
                 # + secret.
                 exclude = { "bus", "changedstate", "secret",
                             "checker", "server_settings" }
-                for name, typ in (inspect.getmembers
-                                  (dbus.service.Object)):
+                for name, typ in inspect.getmembers(dbus.service
+                                                    .Object):
                     exclude.add(name)
                 
                 client_dict["encrypted_secret"] = (client
@@ -2794,12 +2835,14 @@
                 del client_settings[client.name]["secret"]
         
         try:
-            with (tempfile.NamedTemporaryFile
-                  (mode='wb', suffix=".pickle", prefix='clients-',
-                   dir=os.path.dirname(stored_state_path),
-                   delete=False)) as stored_state:
+            with tempfile.NamedTemporaryFile(
+                    mode='wb',
+                    suffix=".pickle",
+                    prefix='clients-',
+                    dir=os.path.dirname(stored_state_path),
+                    delete=False) as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-                tempname=stored_state.name
+                tempname = stored_state.name
             os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
             if not debug:
@@ -2824,9 +2867,8 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client
-                                                  .dbus_object_path,
-                                                  client.name)
+                mandos_dbus_service.ClientRemoved(
+                    client.dbus_object_path, client.name)
         client_settings.clear()
     
     atexit.register(cleanup)
@@ -2885,5 +2927,6 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-10-05 20:08:58 +0000
+++ mandos-ctl	2015-05-31 16:13:39 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -64,8 +64,8 @@
     "ApprovalDelay": "Approval Delay",
     "ApprovalDuration": "Approval Duration",
     "Checker": "Checker",
-    "ExtendedTimeout" : "Extended Timeout"
-    }
+    "ExtendedTimeout": "Extended Timeout"
+}
 defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
 domain = "se.recompile"
 busname = domain + ".Mandos"
@@ -74,14 +74,14 @@
 client_interface = domain + ".Mandos.Client"
 version = "1.6.9"
 
+
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{}T".format(td.days) if td.days else "",
-                    hours = td.seconds // 3600,
-                    minutes = (td.seconds % 3600) // 60,
-                    seconds = td.seconds % 60,
-                    ))
+    return ("{days}{hours:02}:{minutes:02}:{seconds:02}".format(
+        days = "{}T".format(td.days) if td.days else "",
+        hours = td.seconds // 3600,
+        minutes = (td.seconds % 3600) // 60,
+        seconds = td.seconds % 60))
 
 
 def rfc3339_duration_to_delta(duration):
@@ -111,21 +111,17 @@
     # avoid excessive use of external libraries.
     
     # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
     # RFC 3339 "duration" tokens, syntax, and semantics; taken from
     # the "duration" ABNF definition in RFC 3339, Appendix A.
     token_end = Token(re.compile(r"$"), None, frozenset())
     token_second = Token(re.compile(r"(\d+)S"),
                          datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
+                         frozenset((token_end, )))
     token_minute = Token(re.compile(r"(\d+)M"),
                          datetime.timedelta(minutes=1),
                          frozenset((token_second, token_end)))
@@ -147,7 +143,7 @@
                        frozenset((token_month, token_end)))
     token_week = Token(re.compile(r"(\d+)W"),
                        datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
+                       frozenset((token_end, )))
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
@@ -155,7 +151,7 @@
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset((token_duration, )) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -178,7 +174,8 @@
                 break
         else:
             # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
     # End token found
     return value
 
@@ -186,17 +183,17 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
-    >>> string_to_delta("7d")
+    >>> string_to_delta('7d')
     datetime.timedelta(7)
-    >>> string_to_delta("60s")
+    >>> string_to_delta('60s')
     datetime.timedelta(0, 60)
-    >>> string_to_delta("60m")
+    >>> string_to_delta('60m')
     datetime.timedelta(0, 3600)
-    >>> string_to_delta("24h")
+    >>> string_to_delta('24h')
     datetime.timedelta(1)
-    >>> string_to_delta("1w")
+    >>> string_to_delta('1w')
     datetime.timedelta(7)
-    >>> string_to_delta("5m 30s")
+    >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
     
@@ -223,6 +220,7 @@
             value += datetime.timedelta(0, 0, 0, int(num))
     return value
 
+
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
@@ -234,19 +232,18 @@
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
-            width = max(len(tablewords[key]),
-                        max(len(valuetostring(client[key],
-                                              key))
-                            for client in
-                            clients)),
-            key = key) for key in keywords)
+        width = max(len(tablewords[key]),
+                    max(len(valuetostring(client[key], key))
+                        for client in clients)),
+        key = key)
+                             for key in keywords)
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
-                                           valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+        print(format_string.format(**{
+            key: valuetostring(client[key], key)
+            for key in keywords }))
+
 
 def has_actions(options):
     return any((options.enable,
@@ -268,6 +265,7 @@
                 options.approve,
                 options.deny))
 
+
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
@@ -338,8 +336,7 @@
         bus = dbus.SystemBus()
         mandos_dbus_objc = bus.get_object(busname, server_path)
     except dbus.exceptions.DBusException:
-        print("Could not connect to Mandos server",
-              file=sys.stderr)
+        print("Could not connect to Mandos server", file=sys.stderr)
         sys.exit(1)
     
     mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -382,11 +379,10 @@
     
     if not has_actions(options) and clients:
         if options.verbose:
-            keywords = ("Name", "Enabled", "Timeout",
-                        "LastCheckedOK", "Created", "Interval",
-                        "Host", "Fingerprint", "CheckerRunning",
-                        "LastEnabled", "ApprovalPending",
-                        "ApprovedByDefault",
+            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "Fingerprint",
+                        "CheckerRunning", "LastEnabled",
+                        "ApprovalPending", "ApprovedByDefault",
                         "LastApprovalRequest", "ApprovalDelay",
                         "ApprovalDuration", "Checker",
                         "ExtendedTimeout")
@@ -397,16 +393,19 @@
     else:
         # Process each client in the list by all selected options
         for client in clients:
+            
             def set_client_prop(prop, value):
                 """Set a Client D-Bus property"""
                 client.Set(client_interface, prop, value,
                            dbus_interface=dbus.PROPERTIES_IFACE)
+            
             def set_client_prop_ms(prop, value):
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
                                 string_to_delta(value).total_seconds()
                                 * 1000)
+            
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:
@@ -456,5 +455,6 @@
                 client.Approve(dbus.Boolean(False),
                                dbus_interface=client_interface)
 
+
 if __name__ == "__main__":
     main()

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-10-05 20:08:58 +0000
+++ mandos-keygen	2015-05-23 10:41:35 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -47,7 +47,7 @@
     --name "$0" -- "$@"`
 
 help(){
-basename="`basename $0`"
+basename="`basename "$0"`"
 cat <<EOF
 Usage: $basename [ -v | --version ]
        $basename [ -h | --help ]
@@ -113,7 +113,7 @@
     esac
 done
 if [ "$#" -gt 0 ]; then
-    echo "Unknown arguments: '$@'" >&2
+    echo "Unknown arguments: '$*'" >&2
     exit 1
 fi
 
@@ -285,13 +285,19 @@
     esac
     
     if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
+	for ssh_keytype in ed25519 rsa; do
+	    set +e
+	    ssh_fingerprint="`ssh-keyscan -t $ssh_keytype localhost 2>/dev/null`"
+	    set -e
+	    if [ $? -ne 0 ]; then
+		ssh_fingerprint=""
+		continue
+	    fi
+	    if [ -n "$ssh_fingerprint" ]; then
+		ssh_fingerprint="${ssh_fingerprint#localhost }"
+		break
+	    fi
+	done
     fi
     
     # Import key into temporary key rings
@@ -304,7 +310,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir "$RINGDIR" --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
@@ -363,7 +369,7 @@
 	    }
 	}' < "$SECFILE"
     if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
+	echo 'checker = ssh-keyscan -t '"$ssh_keytype"' %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
 	echo "ssh_fingerprint = ${ssh_fingerprint}"
     fi
 fi

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2015-03-10 18:03:38 +0000
@@ -49,25 +49,28 @@
   <para id="priority_compat">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:</literal>
-    <literal>+SIGN-RSA-RMD160</literal></quote>.
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
+    <literal>:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160</literal></quote>.
     See <citerefentry><refentrytitle
     >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
+    communication impossible.  Changing this option may also make the
+    network traffic decryptable by an attacker.
   </para>
   
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP</literal></quote>.  See
-    <citerefentry><refentrytitle >gnutls_priority_init</refentrytitle>
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal></quote>.
+    See <citerefentry><refentrytitle
+    >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
+    communication impossible.  Changing this option may also make the
+    network traffic decryptable by an attacker.
   </para>
   
   <para id="servicename">

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2015-04-02 18:59:29 +0000
@@ -23,7 +23,7 @@
 ;debug = False
 
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2013-10-24 20:21:45 +0000
+++ mandos.conf.xml	2015-04-02 18:59:29 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2013-10-23">
+<!ENTITY TIMESTAMP "2015-04-02">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -223,8 +223,8 @@
 interface = eth0
 address = fe80::aede:48ff:fe71:f6f2
 port = 1025
-debug = true
-priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
+debug = True
+priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA
 servicename = Daena
 use_dbus = False
 use_ipv6 = True

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2015-01-25 00:02:51 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2015-01-25">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -707,8 +707,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.gnu.org/software/gnutls/"
-	  >GnuTLS</ulink>
+	  <ulink url="http://gnutls.org/">GnuTLS</ulink>
 	</term>
       <listitem>
 	<para>
@@ -752,12 +751,12 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.1</citetitle>
+	  RFC 5246: <citetitle>The Transport Layer Security (TLS)
+	  Protocol Version 1.2</citetitle>
 	</term>
       <listitem>
 	<para>
-	  TLS 1.1 is the protocol implemented by GnuTLS.
+	  TLS 1.2 is the protocol implemented by GnuTLS.
 	</para>
       </listitem>
       </varlistentry>
@@ -773,8 +772,8 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
-	  Security</citetitle>
+	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
+	  Security (TLS) Authentication</citetitle>
 	</term>
       <listitem>
 	<para>

=== removed directory 'plugin-helpers'
=== removed file 'plugin-helpers/mandos-client-iprouteadddel.c'
--- plugin-helpers/mandos-client-iprouteadddel.c	2015-07-05 21:38:01 +0000
+++ plugin-helpers/mandos-client-iprouteadddel.c	1970-01-01 00:00:00 +0000
@@ -1,282 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/* 
- * iprouteadddel - Add or delete direct route to a local IP address
- * 
- * Copyright © 2015 Teddy Hogeborn
- * Copyright © 2015 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <mandos@recompile.se>.
- */
-
-#define _GNU_SOURCE		/* asprintf(),
-				   program_invocation_short_name */
-#include <stdbool.h>		/* bool, false, true */
-#include <stdio.h>		/* fprintf(), stderr, FILE, vfprintf */
-#include <errno.h>		/* program_invocation_short_name,
-				   errno, perror(), EINVAL, ENOMEM */
-#include <stdarg.h>		/* va_list, va_start */
-#include <stdlib.h> 		/* EXIT_SUCCESS */
-#include <argp.h>		/* struct argp_option, error_t, struct
-				   argp_state, ARGP_KEY_ARG,
-				   argp_usage(), ARGP_KEY_END,
-				   ARGP_ERR_UNKNOWN, struct argp,
-				   argp_parse() */
-#include <sysexits.h>		/* EX_USAGE, EX_OSERR */
-#include <netinet/ip.h>		/* sa_family_t, AF_INET6, AF_INET */
-#include <inttypes.h>		/* PRIdMAX, intmax_t */
-
-#include <netlink/netlink.h>	/* struct nl_addr, nl_addr_parse(),
-				   nl_geterror(),
-				   nl_addr_get_family(),
-				   nl_addr_put() */
-#include <netlink/route/route.h> /* struct rtnl_route,
-				    struct rtnl_nexthop,
-				    rtnl_route_alloc(),
-				    rtnl_route_set_family(),
-				    rtnl_route_set_protocol(),
-				    RTPROT_BOOT,
-				    rtnl_route_set_scope(),
-				    RT_SCOPE_LINK,
-				    rtnl_route_set_type(),
-				    RTN_UNICAST,
-				    rtnl_route_set_dst(),
-				    rtnl_route_set_table(),
-				    RT_TABLE_MAIN,
-				    rtnl_route_nh_alloc(),
-				    rtnl_route_nh_set_ifindex(),
-				    rtnl_route_add_nexthop(),
-				    rtnl_route_add(),
-				    rtnl_route_delete(),
-				    rtnl_route_put(),
-				    rtnl_route_nh_free() */
-#include <netlink/socket.h>	/* struct nl_sock, nl_socket_alloc(),
-				   nl_connect(), nl_socket_free() */
-#include <netlink/route/link.h>	/* rtnl_link_get_kernel(),
-				   rtnl_link_get_ifindex(),
-				   rtnl_link_put() */
-
-bool debug = false;
-const char *argp_program_version = "mandos-client-iprouteadddel " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
-
-/* Function to use when printing errors */
-void perror_plus(const char *print_text){
-  int e = errno;
-  fprintf(stderr, "Mandos plugin helper %s: ",
-	  program_invocation_short_name);
-  errno = e;
-  perror(print_text);
-}
-
-__attribute__((format (gnu_printf, 2, 3), nonnull))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  fprintf(stream, "Mandos plugin helper %s: ",
-	  program_invocation_short_name);
-  return vfprintf(stream, format, ap);
-}
-
-int main(int argc, char *argv[]){
-  int ret;
-  int exitcode = EXIT_SUCCESS;
-  struct arguments {
-    bool add;			/* true: add, false: delete */
-    char *address;		/* IP address as string */
-    struct nl_addr *nl_addr;	/* Netlink IP address */
-    char *interface;		/* interface name */
-  } arguments = { .add = true, .address = NULL, .interface = NULL };
-  struct argp_option options[] = {
-    { .name = "debug", .key = 128,
-      .doc = "Debug mode" },
-    { .name = NULL }
-  };
-  struct rtnl_route *route = NULL;
-  struct rtnl_nexthop *nexthop = NULL;
-  struct nl_sock *sk = NULL;
-  
-  error_t parse_opt(int key, char *arg, struct argp_state *state){
-    int lret;
-    errno = 0;
-    switch(key){
-    case 128:			/* --debug */
-      debug = true;
-      break;
-    case ARGP_KEY_ARG:
-      switch(state->arg_num){
-      case 0:
-	if(strcasecmp(arg, "add") == 0){
-	  ((struct arguments *)(state->input))->add = true;
-	} else if(strcasecmp(arg, "delete") == 0){
-	  ((struct arguments *)(state->input))->add = false;
-	} else {
-	  fprintf_plus(stderr, "Unrecognized command: %s\n", arg);
-	  argp_usage(state);
-	}
-	break;
-      case 1:
-	((struct arguments *)(state->input))->address = arg;
-	lret = nl_addr_parse(arg, AF_UNSPEC, &(((struct arguments *)
-						(state->input))
-					       ->nl_addr));
-	if(lret != 0){
-	  fprintf_plus(stderr, "Failed to parse address %s: %s\n",
-		       arg, nl_geterror(lret));
-	  argp_usage(state);
-	}
-	break;
-      case 2:
-	((struct arguments *)(state->input))->interface = arg;
-	break;
-      default:
-	argp_usage(state);
-      }
-      break;
-    case ARGP_KEY_END:
-      if(state->arg_num < 3){
-	argp_usage(state);
-      }
-      break;
-    default:
-      return ARGP_ERR_UNKNOWN;
-    }
-    return errno;
-  }
-  
-  struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = "[ add | delete ] ADDRESS INTERFACE",
-		       .doc = "Mandos client helper -- Add or delete"
-		       " local route to IP address on interface" };
-  
-  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, &arguments);
-  switch(ret){
-  case 0:
-    break;
-  case EINVAL:
-    exit(EX_USAGE);
-  case ENOMEM:
-  default:
-    errno = ret;
-    perror_plus("argp_parse");
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Get netlink socket */
-  sk = nl_socket_alloc();
-  if(sk == NULL){
-    fprintf_plus(stderr, "Failed to allocate netlink socket: %s\n",
-		 nl_geterror(ret));
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Connect socket to netlink */
-  ret = nl_connect(sk, NETLINK_ROUTE);
-  if(ret < 0){
-    fprintf_plus(stderr, "Failed to connect socket to netlink: %s\n",
-		 nl_geterror(ret));
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Get link object of specified interface */
-  struct rtnl_link *link = NULL;
-  ret = rtnl_link_get_kernel(sk, 0, arguments.interface, &link);
-  if(ret < 0){
-    fprintf_plus(stderr, "Failed to use interface %s: %s\n",
-		 arguments.interface, nl_geterror(ret));
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Get netlink route object */
-  route = rtnl_route_alloc();
-  if(route == NULL){
-    fprintf_plus(stderr, "Failed to get netlink route:\n");
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Get address family of specified address */
-  sa_family_t af = (sa_family_t)nl_addr_get_family(arguments.nl_addr);
-  if(debug){
-    fprintf_plus(stderr, "Address family of %s is %s (%" PRIdMAX
-		 ")\n", arguments.address,
-		 af == AF_INET6 ? "AF_INET6" :
-		 ( af == AF_INET ? "AF_INET" : "UNKNOWN"),
-		 (intmax_t)af);
-  }
-  /* Set route parameters: */
-  rtnl_route_set_family(route, (uint8_t)af);   /* Address family */
-  rtnl_route_set_protocol(route, RTPROT_BOOT); /* protocol - see
-						  ip-route(8) */
-  rtnl_route_set_scope(route, RT_SCOPE_LINK); /* link scope */
-  rtnl_route_set_type(route, RTN_UNICAST);    /* normal unicast
-						 address route */
-  rtnl_route_set_dst(route, arguments.nl_addr); /* Destination
-						   address */
-  rtnl_route_set_table(route, RT_TABLE_MAIN); /* "main" routing
-						 table */
-  /* Create nexthop */
-  nexthop = rtnl_route_nh_alloc();
-  if(nexthop == NULL){
-    fprintf_plus(stderr, "Failed to get netlink route nexthop\n");
-    exitcode = EX_OSERR;
-    goto end;
-  }
-  /* Get index number of specified interface */
-  int ifindex = rtnl_link_get_ifindex(link);
-  if(debug){
-    fprintf_plus(stderr, "ifindex of %s is %d\n", arguments.interface,
-		 ifindex);
-  }
-  /* Set interface index number on nexthop object */
-  rtnl_route_nh_set_ifindex(nexthop, ifindex);
-  /* Set route tu use nexthop object */
-  rtnl_route_add_nexthop(route, nexthop);
-  /* Add or delete route? */
-  if(arguments.add){
-    ret = rtnl_route_add(sk, route, NLM_F_EXCL);
-  } else {
-    ret = rtnl_route_delete(sk, route, 0);
-  }
-  if(ret < 0){
-     fprintf_plus(stderr, "Failed to %s route: %s\n",
-		  arguments.add ? "add" : "delete",
-		  nl_geterror(ret));
-    exitcode = EX_OSERR;
-    goto end;
-  }
- end:
-  /* Deallocate route */
-  if(route){
-    rtnl_route_put(route);
-  } else if(nexthop) {
-    /* Deallocate route nexthop */
-    rtnl_route_nh_free(nexthop);
-  }
-  /* Deallocate parsed address */
-  if(arguments.nl_addr){
-    nl_addr_put(arguments.nl_addr);
-  }
-  /* Deallocate link struct */
-  if(link){
-    rtnl_link_put(link);
-  }
-  /* Deallocate netlink socket struct */
-   if(sk){
-    nl_socket_free(sk);
-  }
-  return exitcode;
-}

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2015-06-28 16:35:27 +0000
+++ plugin-runner.c	2014-07-16 01:41:23 +0000
@@ -76,7 +76,6 @@
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
-#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
@@ -348,7 +347,6 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
-  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
   struct dirent **direntries = NULL;
@@ -416,10 +414,6 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
-    { .name = "plugin-helper-dir", .key = 133,
-      .arg = "DIRECTORY",
-      .doc = "Specify a different plugin helper directory",
-      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -551,13 +545,6 @@
     case 132:			/* --debug */
       debug = true;
       break;
-    case 133:			/* --plugin-helper-dir */
-      free(pluginhelperdir);
-      pluginhelperdir = strdup(arg);
-      if(pluginhelperdir != NULL){
-	errno = 0;
-      }
-      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -614,7 +601,6 @@
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
-    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -775,24 +761,6 @@
     goto fallback;
   }
   
-  {
-    char *pluginhelperenv;
-    bool bret = true;
-    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
-		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    if(ret != -1){
-      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
-    }
-    if(ret == -1 or not bret){
-      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
-	    " environment variable to \"%s\" for all plugins\n",
-	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    }
-    if(ret != -1){
-      free(pluginhelperenv);
-    }
-  }
-  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -1368,7 +1336,6 @@
   free_plugin_list();
   
   free(plugindir);
-  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2015-06-28 16:35:27 +0000
+++ plugin-runner.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2015-06-28">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -114,9 +114,6 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
-      <arg><option>--plugin-helper-dir=<replaceable
-      >DIRECTORY</replaceable></option></arg>
-      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -323,21 +320,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--plugin-helper-dir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Specify a different plugin helper directory.  The default
-	    is <filename>/lib/mandos/plugin-helpers</filename>, which
-	    will exist in the initial <acronym>RAM</acronym> disk
-	    environment.  (This will simply be passed to all plugins
-	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
-	    variable.  See <xref linkend="writing_plugins"/>)
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -444,11 +426,7 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.  Any helper executables required
-	by the plugin (which are not in the <envar>PATH</envar>) can
-	be placed in the plugin helper directory, the name of which
-	will be made available to the plugin via the
-	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
+	services not available there.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -497,9 +475,7 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.  Also, the <option>--plugin-helper-dir</option> option
-      will affect the environment variable
-      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
+      options.
     </para>
   </refsect1>
   

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2015-07-06 20:09:47 +0000
+++ plugins.d/mandos-client.c	2015-03-10 18:52:09 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2015 Teddy Hogeborn
- * Copyright © 2008-2015 Björn Påhlsson
+ * Copyright © 2008-2014 Teddy Hogeborn
+ * Copyright © 2008-2014 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -493,12 +493,17 @@
   return plaintext_length;
 }
 
+__attribute__((warn_unused_result, const))
+static const char *safe_string(const char *str){
+  if(str == NULL)
+    return "(unknown)";
+  return str;
+}
+
 __attribute__((warn_unused_result))
 static const char *safer_gnutls_strerror(int value){
   const char *ret = gnutls_strerror(value);
-  if(ret == NULL)
-    ret = "(unknown)";
-  return ret;
+  return safe_string(ret);
 }
 
 /* GnuTLS log function callback */
@@ -513,6 +518,7 @@
 			      const char *seckeyfilename,
 			      mandos_context *mc){
   int ret;
+  unsigned int uret;
   
   if(debug){
     fprintf_plus(stderr, "Initializing GnuTLS\n");
@@ -569,10 +575,111 @@
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
+  if(mc->dh_bits == 0){
+    /* Find out the optimal number of DH bits */
+    /* Try to read the private key file */
+    gnutls_datum_t buffer = { .data = NULL, .size = 0 };
+    {
+      int secfile = open(seckeyfilename, O_RDONLY);
+      size_t buffer_capacity = 0;
+      while(true){
+	buffer_capacity = incbuffer((char **)&buffer.data,
+				    (size_t)buffer.size,
+				    (size_t)buffer_capacity);
+	if(buffer_capacity == 0){
+	  perror_plus("incbuffer");
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  break;
+	}
+	ssize_t bytes_read = read(secfile, buffer.data + buffer.size,
+				  BUFFER_SIZE);
+	/* EOF */
+	if(bytes_read == 0){
+	  break;
+	}
+	/* check bytes_read for failure */
+	if(bytes_read < 0){
+	  perror_plus("read");
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  break;
+	}
+	buffer.size += (unsigned int)bytes_read;
+      }
+      close(secfile);
+    }
+    /* If successful, use buffer to parse private key */
+    gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
+    if(buffer.data != NULL){
+      {
+	gnutls_openpgp_privkey_t privkey = NULL;
+	ret = gnutls_openpgp_privkey_init(&privkey);
+	if(ret != GNUTLS_E_SUCCESS){
+	  fprintf_plus(stderr, "Error initializing OpenPGP key"
+		       " structure: %s", safer_gnutls_strerror(ret));
+	  free(buffer.data);
+	  buffer.data = NULL;
+	} else {
+	  ret = gnutls_openpgp_privkey_import(privkey, &buffer,
+					    GNUTLS_OPENPGP_FMT_BASE64,
+					      "", 0);
+	  if(ret != GNUTLS_E_SUCCESS){
+	    fprintf_plus(stderr, "Error importing OpenPGP key : %s",
+			 safer_gnutls_strerror(ret));
+	    privkey = NULL;
+	  }
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  if(privkey != NULL){
+	    /* Use private key to suggest an appropriate sec_param */
+	    sec_param = gnutls_openpgp_privkey_sec_param(privkey);
+	    gnutls_openpgp_privkey_deinit(privkey);
+	    if(debug){
+	      fprintf_plus(stderr, "This OpenPGP key implies using a"
+			   " GnuTLS security parameter \"%s\".\n",
+			   safe_string(gnutls_sec_param_get_name
+				       (sec_param)));
+	    }
+	  }
+	}
+      }
+      if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
+	/* Err on the side of caution */
+	sec_param = GNUTLS_SEC_PARAM_ULTRA;
+	if(debug){
+	  fprintf_plus(stderr, "Falling back to security parameter"
+		       " \"%s\"\n",
+		       safe_string(gnutls_sec_param_get_name
+				   (sec_param)));
+	}
+      }
+    }
+    uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
+    if(uret != 0){
+      mc->dh_bits = uret;
+      if(debug){
+	fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
+		     " implies %u DH bits; using that.\n",
+		     safe_string(gnutls_sec_param_get_name
+				 (sec_param)),
+		     mc->dh_bits);
+      }
+    } else {
+      fprintf_plus(stderr, "Failed to get implied number of DH"
+		   " bits for security parameter \"%s\"): %s\n",
+		   safe_string(gnutls_sec_param_get_name(sec_param)),
+		   safer_gnutls_strerror(ret));
+      goto globalfail;
+    }
+  } else if(debug){
+    fprintf_plus(stderr, "DH bits explicitly set to %u\n",
+		 mc->dh_bits);
+  }
   ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf_plus(stderr, "Error in GnuTLS prime generation (%u bits):"
+		 " %s\n", mc->dh_bits, safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -650,223 +757,6 @@
 static void empty_log(__attribute__((unused)) AvahiLogLevel level,
 		      __attribute__((unused)) const char *txt){}
 
-/* Set effective uid to 0, return errno */
-__attribute__((warn_unused_result))
-error_t raise_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(0) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-__attribute__((warn_unused_result))
-error_t raise_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = raise_privileges();
-  if(ret_errno != 0){
-    errno = old_errno;
-    return ret_errno;
-  }
-  if(setuid(0) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-__attribute__((warn_unused_result))
-error_t lower_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(uid) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Lower privileges permanently */
-__attribute__((warn_unused_result))
-error_t lower_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(setuid(uid) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Helper function to add_local_route() and delete_local_route() */
-__attribute__((nonnull, warn_unused_result))
-static bool add_delete_local_route(const bool add,
-				   const char *address,
-				   AvahiIfIndex if_index){
-  int ret;
-  char helper[] = "mandos-client-iprouteadddel";
-  char add_arg[] = "add";
-  char delete_arg[] = "delete";
-  char debug_flag[] = "--debug";
-  char *pluginhelperdir = getenv("MANDOSPLUGINHELPERDIR");
-  if(pluginhelperdir == NULL){
-    if(debug){
-      fprintf_plus(stderr, "MANDOSPLUGINHELPERDIR environment"
-		   " variable not set; cannot run helper\n");
-    }
-    return false;
-  }
-  
-  char interface[IF_NAMESIZE];
-  if(if_indextoname((unsigned int)if_index, interface) == NULL){
-    perror_plus("if_indextoname");
-    return false;
-  }
-  
-  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
-  if(devnull == -1){
-    perror_plus("open(\"/dev/null\", O_RDONLY)");
-    return false;
-  }
-  pid_t pid = fork();
-  if(pid == 0){
-    /* Child */
-    /* Raise privileges */
-    errno = raise_privileges_permanently();
-    if(errno != 0){
-      perror_plus("Failed to raise privileges");
-      /* _exit(EX_NOPERM); */
-    } else {
-      /* Set group */
-      errno = 0;
-      ret = setgid(0);
-      if(ret == -1){
-	perror_plus("setgid");
-	_exit(EX_NOPERM);
-      }
-      /* Reset supplementary groups */
-      errno = 0;
-      ret = setgroups(0, NULL);
-      if(ret == -1){
-	perror_plus("setgroups");
-	_exit(EX_NOPERM);
-      }
-    }
-    ret = dup2(devnull, STDIN_FILENO);
-    if(ret == -1){
-      perror_plus("dup2(devnull, STDIN_FILENO)");
-      _exit(EX_OSERR);
-    }
-    ret = (int)TEMP_FAILURE_RETRY(close(devnull));
-    if(ret == -1){
-      perror_plus("close");
-      _exit(EX_OSERR);
-    }
-    ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-    if(ret == -1){
-      perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-      _exit(EX_OSERR);
-    }
-    int helperdir_fd = (int)TEMP_FAILURE_RETRY(open(pluginhelperdir,
-						    O_RDONLY
-						    | O_DIRECTORY
-						    | O_PATH
-						    | O_CLOEXEC));
-    if(helperdir_fd == -1){
-      perror_plus("open");
-      _exit(EX_UNAVAILABLE);
-    }
-    int helper_fd = (int)TEMP_FAILURE_RETRY(openat(helperdir_fd,
-						   helper, O_RDONLY));
-    if(helper_fd == -1){
-      perror_plus("openat");
-      _exit(EX_UNAVAILABLE);
-    }
-    TEMP_FAILURE_RETRY(close(helperdir_fd));
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    if(fexecve(helper_fd, (char *const [])
-	       { helper, add ? add_arg : delete_arg, (char *)address,
-		   interface, debug ? debug_flag : NULL, NULL },
-	       environ) == -1){
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-      perror_plus("fexecve");
-      _exit(EXIT_FAILURE);
-    }
-  }
-  if(pid == -1){
-    perror_plus("fork");
-    return false;
-  }
-  int status;
-  pid_t pret = -1;
-  errno = 0;
-  do {
-    pret = waitpid(pid, &status, 0);
-    if(pret == -1 and errno == EINTR and quit_now){
-      int errno_raising = 0;
-      if((errno = raise_privileges()) != 0){
-	errno_raising = errno;
-	perror_plus("Failed to raise privileges in order to"
-		    " kill helper program");
-      }
-      if(kill(pid, SIGTERM) == -1){
-	perror_plus("kill");
-      }
-      if((errno_raising == 0) and (errno = lower_privileges()) != 0){
-	perror_plus("Failed to lower privileges after killing"
-		    " helper program");
-      }
-      return false;
-    }
-  } while(pret == -1 and errno == EINTR);
-  if(pret == -1){
-    perror_plus("waitpid");
-    return false;
-  }
-  if(WIFEXITED(status)){
-    if(WEXITSTATUS(status) != 0){
-      fprintf_plus(stderr, "Error: iprouteadddel exited"
-		   " with status %d\n", WEXITSTATUS(status));
-      return false;
-    }
-    return true;
-  }
-  if(WIFSIGNALED(status)){
-    fprintf_plus(stderr, "Error: iprouteadddel died by"
-		 " signal %d\n", WTERMSIG(status));
-    return false;
-  }
-  fprintf_plus(stderr, "Error: iprouteadddel crashed\n");
-  return false;
-}
-
-__attribute__((nonnull, warn_unused_result))
-static bool add_local_route(const char *address,
-			    AvahiIfIndex if_index){
-  if(debug){
-    fprintf_plus(stderr, "Adding route to %s\n", address);
-  }
-  return add_delete_local_route(true, address, if_index);
-}
-
-__attribute__((nonnull, warn_unused_result))
-static bool delete_local_route(const char *address,
-			       AvahiIfIndex if_index){
-  if(debug){
-    fprintf_plus(stderr, "Removing route to %s\n", address);
-  }
-  return add_delete_local_route(false, address, if_index);
-}
-
 /* Called when a Mandos server is found */
 __attribute__((nonnull, warn_unused_result))
 static int start_mandos_communication(const char *ip, in_port_t port,
@@ -883,7 +773,6 @@
   int retval = -1;
   gnutls_session_t session;
   int pf;			/* Protocol family */
-  bool route_added = false;
   
   errno = 0;
   
@@ -947,7 +836,7 @@
 		 PRIuMAX "\n", ip, (uintmax_t)port);
   }
   
-  tcp_sd = socket(pf, SOCK_STREAM | SOCK_CLOEXEC, 0);
+  tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
     int e = errno;
     perror_plus("socket");
@@ -1042,61 +931,25 @@
     goto mandos_end;
   }
   
-  while(true){
-    if(af == AF_INET6){
-      ret = connect(tcp_sd, (struct sockaddr *)&to,
-		    sizeof(struct sockaddr_in6));
-    } else {
-      ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
-		    sizeof(struct sockaddr_in));
-    }
-    if(ret < 0){
-      if(errno == ENETUNREACH
-	 and if_index != AVAHI_IF_UNSPEC
-	 and connect_to == NULL
-	 and not route_added and
-	 ((af == AF_INET6 and not
-	   IN6_IS_ADDR_LINKLOCAL(&(((struct sockaddr_in6 *)
-				    &to)->sin6_addr)))
-	  or (af == AF_INET and
-	      /* Not a a IPv4LL address */
-	      (ntohl(((struct sockaddr_in *)&to)->sin_addr.s_addr)
-	       & 0xFFFF0000L) != 0xA9FE0000L))){
-	/* Work around Avahi bug - Avahi does not announce link-local
-	   addresses if it has a global address, so local hosts with
-	   *only* a link-local address (e.g. Mandos clients) cannot
-	   connect to a Mandos server announced by Avahi on a server
-	   host with a global address.  Work around this by retrying
-	   with an explicit route added with the server's address.
-	   
-	   Avahi bug reference:
-	   http://lists.freedesktop.org/archives/avahi/2010-February/001833.html
-	   https://bugs.debian.org/587961
-	*/
-	if(debug){
-	  fprintf_plus(stderr, "Mandos server unreachable, trying"
-		       " direct route\n");
-	}
-	int e = errno;
-	route_added = add_local_route(ip, if_index);
-	if(route_added){
-	  continue;
-	}
-	errno = e;
-      }
-      if(errno != ECONNREFUSED or debug){
-	int e = errno;
-	perror_plus("connect");
-	errno = e;
-      }
-      goto mandos_end;
-    }
-    
-    if(quit_now){
-      errno = EINTR;
-      goto mandos_end;
-    }
-    break;
+  if(af == AF_INET6){
+    ret = connect(tcp_sd, (struct sockaddr *)&to,
+		  sizeof(struct sockaddr_in6));
+  } else {
+    ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
+		  sizeof(struct sockaddr_in));
+  }
+  if(ret < 0){
+    if((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
+      int e = errno;
+      perror_plus("connect");
+      errno = e;
+    }
+    goto mandos_end;
+  }
+  
+  if(quit_now){
+    errno = EINTR;
+    goto mandos_end;
   }
   
   const char *out = mandos_protocol_version;
@@ -1285,12 +1138,6 @@
   
  mandos_end:
   {
-    if(route_added){
-      if(not delete_local_route(ip, if_index)){
-	fprintf_plus(stderr, "Failed to delete local route to %s on"
-		     " interface %d", ip, if_index);
-      }
-    }
     int e = errno;
     free(decrypted_buffer);
     free(buffer);
@@ -1722,13 +1569,64 @@
   }
 }
 
+/* Set effective uid to 0, return errno */
+__attribute__((warn_unused_result))
+error_t raise_privileges(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(seteuid(0) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Set effective and real user ID to 0.  Return errno. */
+__attribute__((warn_unused_result))
+error_t raise_privileges_permanently(void){
+  error_t old_errno = errno;
+  error_t ret_errno = raise_privileges();
+  if(ret_errno != 0){
+    errno = old_errno;
+    return ret_errno;
+  }
+  if(setuid(0) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Set effective user ID to unprivileged saved user ID */
+__attribute__((warn_unused_result))
+error_t lower_privileges(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(seteuid(uid) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Lower privileges permanently */
+__attribute__((warn_unused_result))
+error_t lower_privileges_permanently(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(setuid(uid) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
 __attribute__((nonnull))
 void run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
   struct dirent **direntries = NULL;
   if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY | O_DIRECTORY | O_PATH
-		      | O_CLOEXEC);
+    hookdir_fd = open(hookdir, O_RDONLY);
     if(hookdir_fd == -1){
       if(errno == ENOENT){
 	if(debug){
@@ -1759,11 +1657,7 @@
   }
   struct dirent *direntry;
   int ret;
-  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
-  if(devnull == -1){
-    perror_plus("open(\"/dev/null\", O_RDONLY)");
-    return;
-  }
+  int devnull = open("/dev/null", O_RDONLY);
   for(int i = 0; i < numhooks; i++){
     direntry = direntries[i];
     if(debug){
@@ -1793,6 +1687,21 @@
 	perror_plus("setgroups");
 	_exit(EX_NOPERM);
       }
+      ret = dup2(devnull, STDIN_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(devnull, STDIN_FILENO)");
+	_exit(EX_OSERR);
+      }
+      ret = close(devnull);
+      if(ret == -1){
+	perror_plus("close");
+	_exit(EX_OSERR);
+      }
+      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+	_exit(EX_OSERR);
+      }
       ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
       if(ret == -1){
 	perror_plus("setenv");
@@ -1833,9 +1742,7 @@
 	  _exit(EX_OSERR);
 	}
       }
-      int hook_fd = (int)TEMP_FAILURE_RETRY(openat(hookdir_fd,
-						   direntry->d_name,
-						   O_RDONLY));
+      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
       if(hook_fd == -1){
 	perror_plus("openat");
 	_exit(EXIT_FAILURE);
@@ -1844,21 +1751,6 @@
 	perror_plus("close");
 	_exit(EXIT_FAILURE);
       }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = (int)TEMP_FAILURE_RETRY(close(devnull));
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
       if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
 		 environ) == -1){
 	perror_plus("fexecve");
@@ -2115,9 +2007,9 @@
 }
 
 int main(int argc, char *argv[]){
-  mandos_context mc = { .server = NULL, .dh_bits = 1024,
+  mandos_context mc = { .server = NULL, .dh_bits = 0,
 			.priority = "SECURE256:!CTYPE-X.509:"
-			"+CTYPE-OPENPGP", .current_server = NULL,
+			"+CTYPE-OPENPGP:!RSA", .current_server = NULL,
 			.interfaces = NULL, .interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
   error_t ret_errno;
@@ -2312,7 +2204,7 @@
       goto end;
     }
   }
-  
+    
   {
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
@@ -2345,7 +2237,7 @@
 	  TEMP_FAILURE_RETRY(close(seckey_fd));
 	}
       }
-      
+    
       if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
 	int pubkey_fd = open(pubkey, O_RDONLY);
 	if(pubkey_fd == -1){
@@ -2366,7 +2258,7 @@
 	  TEMP_FAILURE_RETRY(close(pubkey_fd));
 	}
       }
-      
+    
       /* Lower privileges */
       ret_errno = lower_privileges();
       if(ret_errno != 0){
@@ -2841,10 +2733,8 @@
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir != NULL){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY
-						  | O_NOFOLLOW
-						  | O_DIRECTORY
-						  | O_PATH));
+    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
+						  O_NOFOLLOW));
     if(tempdir_fd == -1){
       perror_plus("open");
     } else {

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2015-07-01 20:01:26 +0000
+++ plugins.d/mandos-client.xml	2015-03-10 18:52:09 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2015-06-29">
+<!ENTITY TIMESTAMP "2015-03-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2012</year>
       <year>2013</year>
       <year>2014</year>
-      <year>2015</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -312,7 +311,8 @@
 	<listitem>
 	  <para>
 	    Sets the number of bits to use for the prime number in the
-	    TLS Diffie-Hellman key exchange.  Default is 1024.
+	    TLS Diffie-Hellman key exchange.  The default value is
+	    selected automatically based on the OpenPGP key.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -445,22 +445,9 @@
   
   <refsect1 id="environment">
     <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>MANDOSPLUGINHELPERDIR</envar></term>
-	<listitem>
-	  <para>
-	    This environment variable will be assumed to contain the
-	    directory containing any helper executables.  The use and
-	    nature of these helper executables, if any, is
-	    purposefully not documented.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
     <para>
-      This program does not use any other environment variables, not
-      even the ones provided by <citerefentry><refentrytitle
+      This program does not use any environment variables, not even
+      the ones provided by <citerefentry><refentrytitle
       >cryptsetup</refentrytitle><manvolnum>8</manvolnum>
     </citerefentry>.
     </para>

